/* NOTES:

This project was created for BYOND.com's Dream Makers developer site.

(Check members.byond.com/dreammakers for this game's accompanying article, which includes some notes that might be useful
to BYOND developers.)

Feel free to reuse whatever code or icons you like.

The DME file contains the #defines.

*/


var/list/levelIntros = list(\
{"Hello, Joe. I want to play... uh...
<p>
You're not Joe, are you?
<p>
I guess my, heh, crazy assistant wrote down the wrong house number.
<p>
Look, how about you just pick up that hamburger wrapper on your way out, and we'll call it a day."}, \
{"Hello, Kevin. I want to play a game.
<p>
It must take concentration to zip in and out of traffic that's only going half as fast as you are.
<p>
So much concentration that you can't be bothered with petty distractions like using your turn signal.
<p>
Let's see just how fast you can go. Try to stay on the road."}, \
{"Hello, Mr. Loo. I want to place a delivery order.
<p>
Or I would, if you packaged your food with any concern for how much might spill out, or where it might end up.
<p>
It has all ended up here.
<p>
One of these boxes contains a hot spring roll. Deliver it before it gets cold, and you will receive a fortune cookie.
<p>
Fail, and you have no future."}, \
{"Hello, Fred. I want to play a game.
<p>
You're an opinionated man, Fred. And that's fine. It's the American way.
<p>
But really, protesting at funerals -- it's the wrong side of enough.
<p>
If you want to disrupt a funeral, disrupt your own."}, \
{"Hello, Mrs. Sachermutter. I want to play a game.
<p>
You've spared the rod and spoiled your children, and now I'm sending you to time out.
<p>
Sit in the chair and think about what you've done.
<p>
When you've learned your lesson, you may have a couple seconds left to reach the exit."}, \
{"Hello again, Mrs. Sachermutter. It's Double Jeopardy Day here at the Warehouse of Inconvenience.
<p>
Do you smell smoke? No, the building isn't burning; that's tobacco. And it's just as deadly as you incessantly insist it is.
<p>
All you have to do is walk to the exit without dying. Do it for the children."}, \
"THE END ...?" \
)


var/list/levelAssets
var/mob/thePlayer
var/gameOn = 0 //we use this to prevent MouseEntered() from doing anything when the level isn't active
var/currentRound = 0 //not a level, but a single attempt at a level... see spikes for details


world
	name = "That Darn Saw"
	turf = /turf/floor
	//note that we don't need to explicitly define world.view to 13x9, since BYOND detects that the map is "puzzle sized".


	New()
		. = ..()
		spawn(1) RegisterAssets()


	proc/RegisterAssets()
		//when the world starts up, make a list of each level asset for each level.
		//this makes it easy to get to them later without looping through the whole world's contents.
		levelAssets = new /list(world.maxz, 0)

		for(var/obj/levelAsset/LA in world)
			levelAssets[LA.z] += LA


atom
	//the unnamed icon state of pointer.dmi is used as the player's icon.
	mouse_over_pointer = 'pointer.dmi'


turf
	floor
		icon = 'floor.dmi'


mob
	//we don't really do much with the mob in this game; the mouse pointer is the player's avatar,
	//but the mob is still useful for tracking some variables.
	var/readout/timer
	var/lastLevel = 0


	Login()
		//enforce single-player game
		if(key != world.host)
			del src

		if(!loc) //if player's mob is not on the map yet
			thePlayer = src
			spawn(1) SetLevel(START_LEVEL)
			timer = new /readout(src, null, 5, 9)

			thePlayer << \
{"
INSTRUCTIONS
To start playing, move the mouse pointer into the entrance cage. The timer will start ticking.

Move the pointer to the exit, without touching anything deadly, before time runs out.

You may also have to find keys before you can exit.

The red dot between the pointer's feet is the "hot spot." Any other part of the pointer may safely touch obstacles.

If Dream Seeker isn't set to use 32x32 icons, the pointer will be out of proportion, but it won't affect gameplay.

"}


	proc/SetLevel(levelnum)
		Move(locate(7, 5, levelnum))
		ResetLevel(levelnum)


proc/ResetLevel(levelnum)
	if(thePlayer.lastLevel <> levelnum)
		thePlayer.lastLevel = levelnum
		thePlayer << ""
		thePlayer << "<b><center>[levelIntros[levelnum]]</center></b>"

	gameOn = 0

	for(var/obj/levelAsset/LA in levelAssets[levelnum])
		LA.Reset()

	++currentRound


proc/MockFailure()
	gameOn = 0
	thePlayer << ""
	thePlayer << "You fail it!"


proc/Congratulate()
	gameOn = 0
	thePlayer << ""
	thePlayer << "Well done!"


